﻿function RemoveAGSConfiguratorFolder() {
    if(($item = Get-Item -Path "C:\Windows\System32\A-Volute" -ErrorAction SilentlyContinue)) {
        Remove-Item $item -Recurse -ErrorAction SilentlyContinue
    }
}

function StopAudioSrv() {
    if (($item = Get-Service -Name *Audiosrv* -ErrorAction SilentlyContinue)) {
        Stop-Service $item
    }
}

function StartAudioSrv() {
    if (($item = Get-Service -Name *Audiosrv* -ErrorAction SilentlyContinue)) {
        Start-Service $item
    }
}

function RemoveSoftwareComponent() {

    if (($items = Get-Item -Path "C:\Windows\System32\nahimicAPO*" -ErrorAction SilentlyContinue)) {
        ForEach($item in $items) {
            $out = "$($env:TEMP)\$(New-Guid)"
            Move-Item $item -Destination $out
            & "$($PSScriptRoot)\movefile.exe" -accepteula $out '""' /nobanner
        }
    }

    if (($items = Get-Item -Path "C:\Windows\System32\nahimicPnP*" -ErrorAction SilentlyContinue)) {
        ForEach($item in $items) {
            $out = "$($env:TEMP)\$(New-Guid)"
            Move-Item $item -Destination $out
            & "$($PSScriptRoot)\movefile.exe" -accepteula $out '""' /nobanner
        }
    }

    if (($items = Get-Item -Path "C:\Windows\System32\nahimicS*" -ErrorAction SilentlyContinue)) {
        ForEach($item in $items) {
            $out = "$($env:TEMP)\$(New-Guid)"
            Move-Item $item -Destination $out
            & "$($PSScriptRoot)\movefile.exe" -accepteula $out '""' /nobanner
        }
    }

    if (($items = Get-Item -Path "C:\Windows\System32\NhNotifSys.*" -ErrorAction SilentlyContinue)) {
        ForEach($item in $items) {
            $out = "$($env:TEMP)\$(New-Guid)"
            Move-Item $item -Destination $out
            & "$($PSScriptRoot)\movefile.exe" -accepteula $out '""' /nobanner
        }
    }

	if (($items = Get-Item -Path "C:\Windows\System32\NAHIMICV3*" -ErrorAction SilentlyContinue)) {
        ForEach($item in $items) {
            $out = "$($env:TEMP)\$(New-Guid)"
            Move-Item $item -Destination $out
            & "$($PSScriptRoot)\movefile.exe" -accepteula $out '""' /nobanner
        }
    }

    if (($item = Get-Item -LiteralPath "C:\Windows\SysWOW64\nahimicSvc32.exe" -ErrorAction SilentlyContinue)) {
		$out = "$($env:TEMP)\$(New-Guid)"
		Move-Item $item -Destination $out
		& "$($PSScriptRoot)\movefile.exe" -accepteula $out '""' /nobanner
    }
}

function RemoveModulesFolder() {
    if (($item = Get-Item -Path "C:\ProgramData\A-Volute" -ErrorAction SilentlyContinue)) {
        $out = "$($env:TEMP)\$(New-Guid)"
        Move-Item $item -Destination $out
        & "$($PSScriptRoot)\movefile.exe" -accepteula $out '""' /nobanner
    }
}

function RemoveNahimicService() {
    if (($item = Get-Service -DisplayName "Nahimic Service" -ErrorAction SilentlyContinue)) {
        Stop-Service $item
        sc.exe delete "NahimicService"
    }
}

function RemoveRealtekDevices() {
    $devices = Get-PnpDevice -FriendlyName "*Realtek*" | Select FriendlyName,InstanceId
    ForEach($device in $devices) {
       & "$($PSScriptRoot)\devcon.exe" remove "@$($device.InstanceId)"
    }
}

function RemoveNahimicDevices() {
    $devices = Get-PnpDevice -FriendlyName "Nahimic mirroring device" | Select FriendlyName,InstanceId
    ForEach($device in $devices) {
       & "$($PSScriptRoot)\devcon.exe" remove "@$($device.InstanceId)"
    }
	$mirroringswcdevices = Get-PnpDevice -FriendlyName "Nahimic Mirroring Component" | Select FriendlyName,InstanceId
    ForEach($mirroringswcdevice in $mirroringswcdevices) {
       & "$($PSScriptRoot)\devcon.exe" remove "@$($mirroringswcdevice.InstanceId)"
    }
	$aposwcdevices = Get-PnpDevice -FriendlyName "A-Volute*component" | Select FriendlyName,InstanceId
    ForEach($aposwcdevice in $aposwcdevices) {
       & "$($PSScriptRoot)\devcon.exe" remove "@$($aposwcdevice.InstanceId)"
    }
	$lenovo_aposwcdevices = Get-PnpDevice -FriendlyName "Nahimic Nh4 Audio Effects Component" | Select FriendlyName,InstanceId
    ForEach($lenovo_aposwcdevice in $lenovo_aposwcdevices) {
       & "$($PSScriptRoot)\devcon.exe" remove "@$($lenovo_aposwcdevice.InstanceId)"
    }
}

function RestoreDevices() {
    & "$($PSScriptRoot)\devcon.exe" rescan
    Start-Sleep -Seconds 10
}

function GetAvoluteDrivers() {
    $drivers = (pnputil.exe /enum-drivers | out-string) -split "\n"
    $pattern = "(a-volutenhapo4swc.inf)|(a-volutenh3aposwc.inf)|(avolutenh3ext.inf)|(nhmirroringinstallerswc.inf)|(nahimic_mirroring.inf)"
    $result_with_context = $drivers | Select-String -Pattern $pattern -Context 1,0
    $infs = ($result_with_context.Context.PreContext -split " ").Where({$_ -match ".inf"})
    return $infs
}

function RemoveAVoluteDrivers() {
    $infs = GetAvoluteDrivers
    if (($infs.Count -eq 0)) {
        return
    }
    RemoveRealtekDevices
    RemoveNahimicDevices
    ForEach($inf in $infs) {
        pnputil /delete-driver $inf.Trim() /force /uninstall
    }
    RestoreDevices
}

function RemoveRegistryKeys() {
    Remove-Item -Path HKLM:\SOFTWARE\Nahimic\A-Volute.Nahimic -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path HKLM:\SOFTWARE\Nahimic\Mirroring -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path HKLM:\SOFTWARE\Nahimic\Nahimic3 -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path HKLM:\SOFTWARE\Nahimic\NahimicAPO4 -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path HKLM:\SOFTWARE\Nahimic\NahimicV3 -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path HKLM:\SOFTWARE\A-Volute\Nahimic -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path HKCU:\SOFTWARE\A-Volute\Nahimic -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path HKCU:\SOFTWARE\Nahimic\A-Volute.Nahimic -Recurse -ErrorAction SilentlyContinue
    New-PSDrive -Name HKCR -PSProvider Registry -Root HKEY_CLASSES_ROOT
    Remove-Item -Path "HKCR:\AudioEngine\AudioProcessingObjects\{670173E1-78CF-11E5-A837-0800200C9A66}" -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path "HKCR:\AudioEngine\AudioProcessingObjects\{670173E2-78CF-11E5-A837-0800200C9A66}" -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path "HKCR:\AudioEngine\AudioProcessingObjects\{670173E3-78CF-11E5-A837-0800200C9A66}" -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path "HKCR:\AudioEngine\AudioProcessingObjects\{670173E4-78CF-11E5-A837-0800200C9A66}" -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path "HKCR:\AudioEngine\AudioProcessingObjects\{670173F4-78CF-11E5-A837-0800200C9A66}" -Recurse -ErrorAction SilentlyContinue
    Remove-Item -Path "HKCR:\AudioEngine\AudioProcessingObjects\{670173E5-78CF-11E5-A837-0800200C9A66}" -Recurse -ErrorAction SilentlyContinue
}

function RemoveCoffee() {
    $items = Get-Item -Path "HKLM:\SOFTWARE\Microsoft\Windows\CurrentVersion\MMDevices\Audio\Render\*"
    ForEach($item in $items) {
        if (($property = Get-ItemProperty -Path "$($item.PSPath)\FxProperties" -Name "{1da5d803-d492-4edd-8c23-e0c0ffee7f0e},5" -ErrorAction SilentlyContinue)) {
            Remove-ItemProperty -Path "$($item.PSPath)\FxProperties" -Name "{1da5d803-d492-4edd-8c23-e0c0ffee7f0e},5"
        }
    }
}

StopAudioSrv
RemoveAVoluteDrivers
RemoveNahimicService
RemoveAGSConfiguratorFolder
RemoveSoftwareComponent
RemoveModulesFolder
RemoveRegistryKeys
StartAudioSrv
